############################################################################
 #   Copyright (C) 2018 Davide Zoni                                       # 
 #                                                                        # 
 #   This program is free software; you can redistribute it and/or modify # 
 #   it under the terms of the GNU General Public License as published by # 
 #   the Free Software Foundation; either version 2 of the License, or    # 
 #   (at your option) any later version.                                  # 
 #                                                                        # 
 #   This program is distributed in the hope that it will be useful,      # 
 #   but WITHOUT ANY WARRANTY; without even the implied warranty of       # 
 #   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        # 
 #   GNU General Public License for more details.                         # 
 #                                                                        # 
 #   You should have received a copy of the GNU General Public License    # 
 #   along with this program; if not, see <http://www.gnu.org/licenses/>  # 
############################################################################


#!/bin/bash

SLEEP_TIMEOUT_SECONDS=10

HDL_SRC_FOLDER=src

SCRIPT_DIR=`pwd`

#i='10197958'
NUM_TESTS=1


#location of all the git ids waiting for verification
#FIXME absolute path
#WAIT_FOR_VALIDATION_HOME="../WAIT_FOR_VALIDATION_TEST_POST_SYNTH"
WAIT_FOR_VALIDATION_HOME="../WAIT_FOR_VERIFICATION_FOLDER"


# get the xilinx toolchain
source /opt/Xilinx/Vivado/2017.1/settings64.sh


# output file generated by the tb.v
while ((1)); do
        echo "INFO: Verification Script WAKEUP"
        for i in $(ls $WAIT_FOR_VALIDATION_HOME); do
                # NOTE: $i is without the .git suffix
                echo -e "\tINFO: start verification for $i"

                # clone a copy of the repo
                cd ../${HDL_SRC_FOLDER};
		rm -rf $i           
               git clone git-olite@127.0.0.1:$i $i

		# remove any previous log file in RESULT FOLDER
		cd $i
		git rm -r RESULTS/*
				#move back to the script folder
				cd ${SCRIPT_DIR}			

				# run synthesis process first

				echo "##################################"
				echo "Starting synthesis ..."	
				echo "##################################"
				./0_synthesize.sh $i ${HDL_SRC_FOLDER}
				./copySynthLog.sh $i ${HDL_SRC_FOLDER}

# iterate multiple times to generate 
# multiple tests and results for pre 
# and post synth simulations
			for j in $(seq 1 $NUM_TESTS); do
# loop body init
				RES_DEST_DIR=../${HDL_SRC_FOLDER}/${i}/RESULTS/test${j}/
				echo "##################################"
				echo "TEST $j: Starting behavioral simulation ...$i ${HDL_SRC_FOLDER}"
				echo "##################################"
				mkdir -p ${RES_DEST_DIR} 
				mkdir -p ${RES_DEST_DIR}/behav
				mkdir -p ${RES_DEST_DIR}/post_synth

				echo "##################################"
				echo "TEST $j: Creating simulation test ...$i ${HDL_SRC_FOLDER} and copying to result folder ./.${HDL_SRC_FOLDER}/${i}/test${j}/"
				echo "##################################"
				python2.7 tb_gen.py > ../tb/test${j}.vhdl	
				cp ../tb/test${j}.vhdl ${RES_DEST_DIR}

				echo "##################################"
				echo "TEST $j: Starting behavioral simulation ...$i ${HDL_SRC_FOLDER}"
				echo "##################################"
				# run the behavioral simulation for repo $i
				./1_simBehavioral.sh $i ${HDL_SRC_FOLDER} ../tb/test${j}.vhdl
				./copyPreSynthSimLog.sh ${RES_DEST_DIR}/behav

				echo "##################################"
				echo "TEST $j: Starting post-synth simulation ..."
				echo "##################################"
				# run the post-synthesis simulation for repo $i
				./2_simPostSynthesis.sh ../tb/test${j}.vhdl
				./copyPostSynthSimLog.sh ${RES_DEST_DIR}/post_synth


				./clean.sh
				# clean the testbench from tb folder
				rm ../tb/test${j}.vhdl
	
			done
	# end loop random test simulation	
			echo "##################################"
			echo "Committing results to the repo ..."
			echo "##################################"
			# commit results for repo $i
			./commitResults.sh $i ${HDL_SRC_FOLDER}

			##clean up repo $i
			## 1) clear src cloned repo dir
			rm -rf ../${HDL_SRC_FOLDER}/$i 
			## 2) clean script dir
			./clean.sh
			rm project_reti_logiche_synth.v
 
			## 3) remove the token
			rm -f ${WAIT_FOR_VALIDATION_HOME}"/"$i

		done # loop over the TOKENS

		echo -e "INFO: Verification Script SLEEP now"
		sleep ${SLEEP_TIMEOUT_SECONDS}
done
